create or replace
PROCEDURE ATUALIZA_INVENTARIO_ESTOQUE(
   P_EVOLEST IN VARCHAR2,
   P_CDFILIMOVI IN VARCHAR2,
   P_CDFILIAL IN VARCHAR2,
   P_CDOPERADOR IN VARCHAR2,
   P_DATAPROC IN DATE,
   P_INOPCAO IN NUMBER,
   P_CDSERVFILI IN VARCHAR2,
   P_CDTIPORETI IN VARCHAR2,
   P_CDCENTCUST IN VARCHAR2,
   P_CDSETOR IN VARCHAR2,
   P_RETIESTQ IN VARCHAR2,
   P_CDALMOXARIFE IN VARCHAR2,
   P_CDLOCALESTOQ IN VARCHAR2)
AS
BEGIN
   DECLARE
      V_IDORDAJUINVE   VARCHAR2(1);
      V_IDGERARETAJU   VARCHAR2(1);
      V_IDUTILALMOX    VARCHAR2(1);
      V_IDUTILLCESTQ   VARCHAR2(1);
      V_IDUTILLOTE     VARCHAR2(1);
      V_IDORDEMCLC     VARCHAR2(1);
      V_IDCTRLESTQ     VARCHAR2(1);
      V_CDPRODESTO     VARCHAR2(10);
      V_VRFATOCONV     NUMBER;
      V_CUSTOPROD      NUMBER;
      V_QTINVROTA      NUMBER;
      V_QTESTOQDIA     NUMBER;
      V_ALMOXARIF      VARCHAR2(6);
      V_LOCALEST       VARCHAR2(6);
      V_NRAJUSTE       VARCHAR2(20);
      V_NRSEQAJU       NUMBER;
      V_DESCALMOX      VARCHAR2(60);
      V_TIPOMOV        VARCHAR2(1);
      V_NRLANCVER      VARCHAR2(20);
      V_NRLANCESTRET   VARCHAR2(20);
      V_NRRETIRADA     VARCHAR2(20);
      V_NRCARDAPIO     VARCHAR2(20);
      V_DTPOSESTDIA    DATE;
      V_CONTADOR       NUMBER;
      v_nrimplanta     varchar2(20);
      V_NRSEQIMP       NUMBER;
      V_DTMOVI         DATE;
      V_QTLANCSAID     NUMBER;
      V_COUNTIRREG     NUMBER;
      V_NRLANCIRREST   VARCHAR2(20);
      V_NRITEMIRREG    NUMBER;

      CURSOR C_INVENTOK IS
         SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.QTINVEROTA, I.QTESTOQUE,P.NMPRODUTO,P.CDARVPROD
           FROM INVEROTA I,PRODUTO P,
                (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                   FROM INVEROTA
                  WHERE CDFILIAL = P_CDFILIAL
                    AND ((INSTR(P_CDALMOXARIFE, '_'||CDALMOXARIFE||'_') > 0) OR (P_CDALMOXARIFE = ' '))
                    AND ((INSTR(P_CDLOCALESTOQ, '_'||CDLOCALESTOQ||'_') > 0) OR (P_CDLOCALESTOQ = ' '))
                    AND DTINVEROTA < P_DATAPROC
                  GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) X
          WHERE I.CDFILIAL = P_CDFILIAL
            AND ((INSTR(P_CDALMOXARIFE, '_'||I.CDALMOXARIFE||'_') > 0) OR (P_CDALMOXARIFE = ' '))
            AND ((INSTR(P_CDLOCALESTOQ, '_'||I.CDLOCALESTOQ||'_') > 0) OR (P_CDLOCALESTOQ = ' '))
            AND I.IDINVENTOK = 'N'
            AND I.CDFILIAL = X.CDFILIAL
            AND I.CDPRODUTO = X.CDPRODUTO
            AND I.CDALMOXARIFE = X.CDALMOXARIFE
            AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
            AND I.DTINVEROTA = X.DTINVEROTA
            AND I.CDPRODUTO  = P.CDPRODUTO
          ORDER BY I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ;

      CURSOR C_INVLOTEOK IS
         SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE, I.QTINVELOTE, I.QTESTOLOTE,P.NMPRODUTO,P.CDARVPROD
           FROM INVEROTALOTE I,PRODUTO P,
                (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                   FROM INVEROTALOTE
                  WHERE CDFILIAL = P_CDFILIAL
                    AND ((INSTR(P_CDALMOXARIFE, '_'||CDALMOXARIFE||'_') > 0) OR (P_CDALMOXARIFE = ' '))
                    AND ((INSTR(P_CDLOCALESTOQ, '_'||CDLOCALESTOQ||'_') > 0) OR (P_CDLOCALESTOQ = ' '))
                    AND DTINVELOTE < P_DATAPROC
                  GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
          WHERE I.CDFILIAL = P_CDFILIAL
            AND ((INSTR(P_CDALMOXARIFE, '_'||I.CDALMOXARIFE||'_') > 0) OR (P_CDALMOXARIFE = ' '))
            AND ((INSTR(P_CDLOCALESTOQ, '_'||I.CDLOCALESTOQ||'_') > 0) OR (P_CDLOCALESTOQ = ' '))
            AND I.IDINVLOTEOK = 'N'
            AND I.CDFILIAL = X.CDFILIAL
            AND I.CDPRODUTO = X.CDPRODUTO
            AND I.CDALMOXARIFE = X.CDALMOXARIFE
            AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
            AND I.NRLOTEESTQ = X.NRLOTEESTQ
            AND I.NRSUBLOTE = X.NRSUBLOTE
            and I.DTINVELOTE = X.DTINVELOTE
            AND I.CDPRODUTO  = P.CDPRODUTO
          ORDER BY I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ;

   BEGIN
      SELECT IDORDAJUINVE, IDGERARETAJU, IDUTILALMOX, IDUTILLCESTQ, IDUTILLOTE, IDCTRLESTQ
        INTO V_IDORDAJUINVE, V_IDGERARETAJU, V_IDUTILALMOX, V_IDUTILLCESTQ, V_IDUTILLOTE, V_IDCTRLESTQ
        FROM PARAMFILIAL
       WHERE CDFILIAL = P_CDFILIAL;

      IF (V_IDORDAJUINVE IS NULL) OR (V_IDORDAJUINVE = 'P') THEN
         V_IDORDEMCLC := 'O';
      ELSE
         V_IDORDEMCLC := 'U';
      END IF;

      V_NRAJUSTE := '';
      V_NRLANCVER := '';
      V_NRIMPLANTA := '';
      V_NRLANCIRREST := '';
      V_ALMOXARIF := 'NOVO';
      V_LOCALEST  := 'NOVO';

      V_NRITEMIRREG :=0;
      V_COUNTIRREG  :=0;
      V_QTLANCSAID  :=0;

      NOVO_CODIGO('TRAB_IRREG_EST'||P_CDFILIAL, V_NRLANCIRREST);
      V_NRLANCIRREST := SUBSTR(V_NRLANCIRREST, 11, 20);
      V_COUNTIRREG := 0;
      IF (V_IDUTILLOTE <> 'S') THEN
         IF P_INOPCAO = 10 OR P_INOPCAO = 12 THEN
            FOR C_VERIFESTOQUE IN C_INVENTOK LOOP
               IF V_IDORDEMCLC = 'O' AND V_IDGERARETAJU = 'S' THEN
                  BEGIN
                     SELECT SUM(A.QTLANCTOEST)
                       INTO V_QTLANCSAID
                       FROM ITLANCTOEST A, PRODUTO B
                      WHERE (A.CDFILIMOVI      = P_CDFILIMOVI)
                        AND (A.CDPRODUTO     = C_VERIFESTOQUE.CDPRODUTO)
                        AND (B.CDPRODUTO     = A.CDPRODUTO)
                        AND (A.CDALMOXARIFE  = C_VERIFESTOQUE.CDALMOXARIFE)
                        AND (A.CDLOCALESTOQ  = C_VERIFESTOQUE.CDLOCALESTOQ)
                        AND (A.IDTIPOMOVI IN ('3','4'))
                        AND (A.DTLANCMOVI BETWEEN P_DATAPROC - 1 AND SYSDATE + (SELECT (DECODE(NRDIASSAIDPDFIL,NULL,
                                                                                   (SELECT NRDIASSAIDPD FROM PARAMESTOQUE ),NRDIASSAIDPDFIL)) AS NRDIASSAIDA
                                                                              FROM PARAMFILIAL
                                                                             WHERE CDFILIAL = P_CDFILIMOVI))
                     GROUP BY A.CDFILIAL,A.CDPRODUTO, A.DTLANCMOVI,B.NMPRODUTO;
                  EXCEPTION
                    WHEN NO_DATA_FOUND THEN BEGIN
                      V_QTLANCSAID := 0;
                    END;
                  END;
               ELSE
                  BEGIN
                     SELECT SUM(A.QTLANCTOEST)
                       INTO V_QTLANCSAID
                       FROM ITLANCTOEST A, PRODUTO B
                      WHERE (A.CDFILIMOVI      = P_CDFILIMOVI)
                        AND (A.CDPRODUTO     = C_VERIFESTOQUE.CDPRODUTO)
                        AND (B.CDPRODUTO     = A.CDPRODUTO)
                        AND (A.CDALMOXARIFE  = C_VERIFESTOQUE.CDALMOXARIFE)
                        AND (A.CDLOCALESTOQ  = C_VERIFESTOQUE.CDLOCALESTOQ)
                        AND (A.IDTIPOMOVI IN ('3','4'))
                        AND (A.DTLANCMOVI BETWEEN P_DATAPROC AND SYSDATE + (SELECT (DECODE(NRDIASSAIDPDFIL,NULL,
                                                                                   (SELECT NRDIASSAIDPD FROM PARAMESTOQUE ),NRDIASSAIDPDFIL)) AS NRDIASSAIDA
                                                                              FROM PARAMFILIAL
                                                                             WHERE CDFILIAL = P_CDFILIMOVI))
                     GROUP BY A.CDFILIAL,A.CDPRODUTO, A.DTLANCMOVI,B.NMPRODUTO;
                  EXCEPTION
                    WHEN NO_DATA_FOUND THEN BEGIN
                      V_QTLANCSAID := 0;
                    END;
                  END;
               END IF;

               IF (V_QTLANCSAID  > C_VERIFESTOQUE.QTINVEROTA)THEN
                   V_NRITEMIRREG := V_NRITEMIRREG +1;
                   INSERT INTO TRAB_IRREG_EST(NRLANCIRREST,
                                              NRITEMIRREG,
                                              CDFILIAL,
                                              CDPRODUTO,
                                              NMPRODUTO,
                                              CDALMOXARIFE,
                                              CDLOCALESTOQ,
                                              QTINVEROTA,
                                              QTLANCSAID)
                   VALUES (V_NRLANCIRREST,
                           V_NRITEMIRREG,
                           C_VERIFESTOQUE.CDFILIAL,
                           C_VERIFESTOQUE.CDPRODUTO,
                           C_VERIFESTOQUE.NMPRODUTO,
                           C_VERIFESTOQUE.CDALMOXARIFE,
                           C_VERIFESTOQUE.CDLOCALESTOQ,
                           C_VERIFESTOQUE.QTINVEROTA,
                           V_QTLANCSAID);
                           V_COUNTIRREG := V_COUNTIRREG + 1;
                   COMMIT;
               END IF;
            END LOOP;

            IF (V_COUNTIRREG  > 0) THEN
               RAISE_APPLICATION_ERROR(-20502,V_NRLANCIRREST, TRUE);
            END IF;
         END IF;
         /* INVENTARIO ROTATIVO*/
         /* INCLUSAO DE AJUSTE E DE RETIRADA */
         FOR C_ATUAINVENTOK IN C_INVENTOK LOOP
            SELECT CDPRODESTO, VRFATOCONV
              INTO V_CDPRODESTO, V_VRFATOCONV
              FROM PRODUTO
             WHERE CDPRODUTO = C_ATUAINVENTOK.CDPRODUTO;

            V_CUSTOPROD := CUSTO_PRODUTO_LCEST(C_ATUAINVENTOK.CDFILIAL, V_CDPRODESTO, 3, P_DATAPROC, SYSDATE,
                                               C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, ' ', ' ');

            IF (V_CUSTOPROD IS NULL) THEN
               V_CUSTOPROD := 0;
            ELSE
               V_CUSTOPROD := V_CUSTOPROD * V_VRFATOCONV;
            END IF;

            IF (C_ATUAINVENTOK.QTESTOQUE = 0) THEN
               V_QTESTOQDIA := C_ATUAINVENTOK.QTESTOQUE;
            ELSE
               V_QTESTOQDIA := C_ATUAINVENTOK.QTESTOQUE / V_VRFATOCONV;
            END IF;

            IF (V_VRFATOCONV = 1) THEN
               V_QTINVROTA := C_ATUAINVENTOK.QTINVEROTA;
            ELSE
               V_QTINVROTA := C_ATUAINVENTOK.QTINVEROTA * V_VRFATOCONV;
            END IF;

            IF (V_IDORDAJUINVE = 'U') THEN
               V_DTPOSESTDIA := C_ATUAINVENTOK.DTINVEROTA ;
            ELSE
               V_DTPOSESTDIA := C_ATUAINVENTOK.DTINVEROTA - 1;
            END IF;

            IF (V_CUSTOPROD > 0) THEN
               V_TIPOMOV := '1';
               /* CASO HAJA UMA MUDANCA DE ALMOXARIFADO OU LOCALIZACAO, OU O NMERO DE ITENS DE LANCAMENTOS ATINGIR SEU VALOR MAXIMO,
                SERA INCLUIDO UM NOVO AJUSTE */
               IF ((V_ALMOXARIF <> C_ATUAINVENTOK.CDALMOXARIFE) OR (V_LOCALEST <> C_ATUAINVENTOK.CDLOCALESTOQ) OR (V_NRSEQAJU = 9999)) THEN
                  IF (V_NRAJUSTE IS NOT NULL) THEN
                     IF ((P_INOPCAO = 3) AND ((V_ALMOXARIF <> C_ATUAINVENTOK.CDALMOXARIFE) OR (V_LOCALEST <> C_ATUAINVENTOK.CDLOCALESTOQ))) THEN
                        /* SE A OPCAO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
                        E QUE NAO ESTAO CADASTRADOS NO INVENTARIO, SERAO ZERADOS */
                        FOR C_ZERAEST IN (SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
                                            FROM POSESTDIA A,
                                                 (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                                                    FROM POSESTDIA
                                                   WHERE CDFILIAL = P_CDFILIAL
                                                     AND CDALMOXARIFE = V_ALMOXARIF
                                                     AND CDLOCALESTOQ = V_LOCALEST
                                                     AND DTPOSIESTQ < V_DTMOVI
                                                   GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
                                           WHERE A.CDFILIAL = P_CDFILIAL
                                             AND A.CDALMOXARIFE = V_ALMOXARIF
                                             AND A.CDLOCALESTOQ = V_LOCALEST
                                             AND A.CDFILIAL = X.CDFILIAL
                                             AND A.CDPRODUTO = X.CDPRODUTO
                                             AND A.CDALMOXARIFE = X.CDALMOXARIFE
                                             AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                                             AND A.NRLOTEESTQ = X.NRLOTEESTQ
                                             AND A.NRSUBLOTE = X.NRSUBLOTE
                                             AND A.DTPOSIESTQ = X.DTPOSIESTQ
                                             AND A.QTESTOQDIA <> 0
                                             AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO
                                                               FROM INVEROTA I,
                                                                    (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                                                                       FROM INVEROTA
                                                                      WHERE CDFILIAL = P_CDFILIAL
                                                                        AND CDALMOXARIFE = V_ALMOXARIF
                                                                        AND CDLOCALESTOQ = V_LOCALEST
                                                                        AND DTINVEROTA < V_DTMOVI
                                                                      GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) B
                                                              WHERE I.CDFILIAL = P_CDFILIAL
                                                                AND I.CDALMOXARIFE = V_ALMOXARIF
                                                                AND I.CDLOCALESTOQ = V_LOCALEST
                                                                AND I.CDFILIAL = B.CDFILIAL
                                                                AND I.CDPRODUTO = B.CDPRODUTO
                                                                AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                                                AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                                                AND I.DTINVEROTA = B.DTINVEROTA
                                                                AND A.CDFILIAL = I.CDFILIAL
                                                                AND A.CDPRODUTO = I.CDPRODUTO
                                                                AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                                                AND A.CDLOCALESTOQ = I.CDLOCALESTOQ)) LOOP
                           IF (V_NRSEQAJU = 9999) THEN
                              IF (P_EVOLEST = 'S') THEN
                                 FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                                      FROM MOVILOTE
                                                     WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                                    UPDATE ITLANCTOEST
                                       SET IDEVOLESTOQ = 'S'
                                     WHERE CDFILIAL = P_CDFILIAL
                                       AND NRLANCESTQ = V_NRAJUSTE
                                       AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                                       AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                                       AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                                       AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                                       AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                                 END LOOP;
                                 ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);
                              ELSE
                                 UPDATE ITLANCTOEST
                                    SET IDEVOLESTOQ = 'N'
                                  WHERE CDFILIAL = P_CDFILIAL
                                    AND NRLANCESTQ = V_NRAJUSTE;
                              END IF;

                              NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE);
                              V_NRAJUSTE := SUBSTR(V_NRAJUSTE, 11, 20);

                              INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                              VALUES (P_CDFILIAL, V_NRAJUSTE, V_TIPOMOV, V_DTMOVI, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);

                              V_NRSEQAJU := 0;
                           END IF;
                           V_NRSEQAJU := V_NRSEQAJU + 1;

                           INSERT INTO ITLANCTOEST
                              (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE,
                               CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                           VALUES
                              (P_CDFILIAL, V_NRAJUSTE, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ZERAEST.CDPRODUTO, 0, 0, C_ZERAEST.CDPRODUTO, 'N', P_CDFILIMOVI, C_ZERAEST.CDALMOXARIFE,
                               C_ZERAEST.CDLOCALESTOQ, C_ZERAEST.NRLOTEESTQ, C_ZERAEST.NRSUBLOTE, '1', 0, 0, V_DTMOVI, 0, 0, V_IDORDEMCLC);

                           UPDATE (SELECT E.*
                                     FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                                   AND E.NRLANCTONF  = I.NRLANCTONF
                                                                                   AND E.NRSEQITPROD = I.NRSEQITPROD
                                    WHERE I.CDFILIMOVI   = P_CDFILIMOVI
                                      AND I.CDPRODUTO    = C_ZERAEST.CDPRODUTO
                                      AND I.CDALMOXARIFE = C_ZERAEST.CDALMOXARIFE
                                      AND I.NRLOTEESTQ   = C_ZERAEST.NRLOTEESTQ
                                      AND I.CDLOCALESTOQ = C_ZERAEST.CDLOCALESTOQ
                                      AND I.NRSUBLOTE    = C_ZERAEST.NRSUBLOTE
                                      AND E.IDSTATUSETIQ <> 'I')
                              SET IDSTATUSETIQ = 'I',
                                  DSNOTAFISORIGET = 'INV '||TO_CHAR(SYSDATE, 'DD/MM/YYYY');

                        END LOOP;
                     END IF;
                     /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZACAO ANTERIOR */
                     IF (P_EVOLEST = 'S') THEN
                        FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                             FROM MOVILOTE
                                            WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ = 'S'
                            WHERE CDFILIAL = P_CDFILIAL
                              AND NRLANCESTQ = V_NRAJUSTE
                              AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                              AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                              AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                              AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                              AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                        END LOOP;
                        ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);
                     ELSE
                        UPDATE ITLANCTOEST
                           SET IDEVOLESTOQ = 'N'
                         WHERE CDFILIAL = P_CDFILIAL
                           AND NRLANCESTQ = V_NRAJUSTE;
                     END IF;
                  END IF;

                  V_ALMOXARIF := C_ATUAINVENTOK.CDALMOXARIFE;
                  V_LOCALEST := C_ATUAINVENTOK.CDLOCALESTOQ;
                  V_DTMOVI   := C_ATUAINVENTOK.DTINVEROTA;

                  NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE);
                  V_NRAJUSTE := SUBSTR(V_NRAJUSTE, 11, 20);

                  V_DESCALMOX := 'Ajuste para Inventario Rotativo';
                  IF (V_IDUTILALMOX = 'S') THEN
                     V_DESCALMOX := V_DESCALMOX||' - Almox. '||C_ATUAINVENTOK.CDALMOXARIFE;
                     if (v_idutillcestq = 'S') then
                        V_DESCALMOX := V_DESCALMOX||' Local. '||C_ATUAINVENTOK.CDLOCALESTOQ;
                     END IF;
                  end if;
                  /* Insere o lanamento de Ajuste da retirada no estoque */
                  /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - AJUSTE */
                  INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                  VALUES (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, V_TIPOMOV, C_ATUAINVENTOK.DTINVEROTA, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);

                  V_NRSEQAJU := 0;
               END IF;

               V_NRSEQAJU := V_NRSEQAJU + 1;

               IF (V_IDGERARETAJU = 'S') THEN
                  /* SE ESTA PARAMETRIZADO PARA REALIZAR RETIRADA AO REALIZAR AJUSTE NO ESTOQUE */
                  IF (P_RETIESTQ <> 'S') THEN
                     /* SE A RETIRADA E POR SERVICO */
                     IF ((P_CDSERVFILI IS NOT NULL) AND (C_ATUAINVENTOK.QTINVEROTA < V_QTESTOQDIA)) THEN
                        /* SE O SERVICO FOI INFORMADO E SE A QUANTIDADE DO INVENTARIO E MENOR QUE A QUANTIDADE EM ESTOQUE */
                        IF ((V_NRLANCVER IS NULL) OR (V_NRLANCVER <> V_NRAJUSTE)) THEN
                           /* VERIFICA SE HOUVE MUDANCA DE LANCAMENTO DE AJUSTE */
                           IF (V_NRLANCVER IS NOT NULL) THEN
                              /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTACAO ANTERIOR */
                              IF (P_EVOLEST = 'S') THEN
                                 FOR C_MOVIRET IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                                     FROM MOVILOTE
                                                    WHERE NRMOVILOTE = P_CDFILIAL || V_NRLANCESTRET) LOOP
                                    UPDATE ITLANCTOEST
                                       SET IDEVOLESTOQ = 'S'
                                     WHERE CDFILIAL = P_CDFILIAL
                                       AND NRLANCESTQ = V_NRLANCESTRET
                                       AND CDPRODUTO = C_MOVIRET.CDPRODUTO
                                       AND CDALMOXARIFE = C_MOVIRET.CDALMOXARIFE
                                       AND CDLOCALESTOQ = C_MOVIRET.CDLOCALESTOQ
                                       AND NRLOTEESTQ  = C_MOVIRET.NRLOTEESTQ
                                       AND NRSUBLOTE = C_MOVIRET.NRSUBLOTE;
                                 END LOOP;
                                 ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRLANCESTRET);
                              ELSE
                                 UPDATE ITLANCTOEST
                                    SET IDEVOLESTOQ = 'N'
                                  WHERE CDFILIAL = P_CDFILIAL
                                    AND NRLANCESTQ = V_NRLANCESTRET;
                              END IF;
                           END IF;
                           /* CARREGA AS INFORMACOES DA RETIRADA, DO CARDAPIO E DA RETIRADA DE ESTOQUE REFERENTES AO AJUSTE INFORMADO */
                           BEGIN
                              SELECT AR.NRLANCESTRET, RE.NRRETIRADA, CD.NRCARDAPIO
                                INTO V_NRLANCESTRET, V_NRRETIRADA, V_NRCARDAPIO
                                FROM CARDADIA CD, RETIRADA RE, AJURELACRET AR
                               WHERE CD.NRCARDAPIO = RE.NRCARDAPIO
                                 AND CD.CDFILIAL = RE.CDFILIAL
                                 AND RE.NRLANCESTQ = AR.NRLANCESTRET
                                 AND RE.CDFILANCESTQ = AR.CDFILIAL
                                 AND AR.CDFILIALRET = C_ATUAINVENTOK.CDFILIAL
                                 AND AR.NRLANCESTQ = V_NRAJUSTE
                                 AND AR.CDFILIAL = C_ATUAINVENTOK.CDFILIAL;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN BEGIN
                                 V_NRLANCESTRET := '';
                                 V_NRRETIRADA := '';
                                 V_NRCARDAPIO := '';
                              END;
                           END;

                           IF ((V_NRLANCESTRET IS NULL) AND (V_NRRETIRADA IS NULL) AND (V_NRCARDAPIO IS NULL)) THEN
                              /* CASO NAO TENHA INFORMACOES DE RETIRADA CADASTRADAS */

                              /* LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                              NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);
                              V_NRLANCESTRET := SUBSTR(V_NRLANCESTRET, 11, 20);

                              INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                              VALUES (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, '3', V_DTPOSESTDIA, P_CDFILIMOVI, P_CDOPERADOR, 'Retirada para Ajuste : '||V_NRAJUSTE);

                              /* CARDAPIO */
                              /* VERIFICA A EXISTENCIA DE CARDAPIO */
                              BEGIN
                                 SELECT NRCARDAPIO
                                   INTO V_NRCARDAPIO
                                   FROM CARDADIA
                                  WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                                    AND CDSERVFILI = P_CDSERVFILI
                                    AND DTCARDAPIO = V_DTPOSESTDIA;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN BEGIN
                                    V_NRCARDAPIO := '';
                                 END;
                              END;

                              IF (V_NRCARDAPIO IS NULL) THEN
                                 /* SE NAO EXISTIR CARDAPIO, SERA INCLUIDO UM NOVO */
                                 NOVO_CODIGO('CARDAPIO'||C_ATUAINVENTOK.CDFILIAL, V_NRCARDAPIO);
                                 V_NRCARDAPIO := SUBSTR(V_NRCARDAPIO, 11, 20);

                                 INSERT INTO CARDADIA
                                 (CDFILIAL, NRCARDAPIO, CDSERVFILI, CDOPERADOR, DTCARDAPIO, DTMESCARD)
                                 VALUES
                                 (C_ATUAINVENTOK.CDFILIAL, V_NRCARDAPIO, P_CDSERVFILI, P_CDOPERADOR, V_DTPOSESTDIA, TO_DATE('01/'||TO_CHAR(V_DTPOSESTDIA,'MM/YYYY')));
                              END IF;

                              /* RETIRADA */
                              NOVO_CODIGO('RETIRADA'||C_ATUAINVENTOK.CDFILIAL, V_NRRETIRADA);
                              V_NRRETIRADA := SUBSTR(V_NRRETIRADA, 11, 20);

                              INSERT INTO RETIRADA
                              (CDFILIAL, NRRETIRADA, NRCARDAPIO, DTRETIRADA, CDFILANCESTQ, NRLANCESTQ)
                              VALUES
                              (P_CDFILIMOVI, V_NRRETIRADA, V_NRCARDAPIO, V_DTPOSESTDIA, C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);

                              /* RELACIONAMENTO AJUSTE/RETIRADA */
                              INSERT INTO AJURELACRET
                              (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                              VALUES
                              (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);
                           END IF;

                           /* VERIFICA SE O LANCAMENTO DE RETIRADA DE ESTOQUE POSSUI REGISTRO (A AVALIAR)*/
                           SELECT COUNT(*)
                             INTO V_CONTADOR
                             FROM ITLANCTOEST
                            WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                              AND NRLANCESTQ = V_NRLANCESTRET;

                           IF V_CONTADOR > 0 THEN
                              /* CASO EXISTA REGISTROS, ESSES REGISTROS SERAO DELETADOS (A AVALIAR) */
                              DELETE FROM ITEMRETI
                               WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                                 AND NRRETIRADA = V_NRRETIRADA
                                 AND NRCARDAPIO = V_NRCARDAPIO;

                              DELETE FROM ITLANCTOEST
                               WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                                 AND NRLANCESTQ = V_NRLANCESTRET;
                           END IF;

                           V_NRLANCVER := V_NRAJUSTE;
                        END IF;
                        /* NESTE LOCAL DA TELA TEM UMA VERIFICACAO NA TELA DE INVENTARIO QUE, CASO O LANCAMENTO DE ESTOQUE - RETIRADA TENHA
                           ALGUM ITEM CADASTRADO NAQUELA POSICAO DE ITEM, SERA DELETADO PARA INSERIR UM NOVO REGISTRO NESTA POSICAO (A VERIFICAR) */

                        /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                        INSERT INTO ITLANCTOEST
                        (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST,
                        QTTOTLANCTO, CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI,
                        IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO)
                        VALUES
                        (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO, (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVEROTA),
                        (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVEROTA), V_CDPRODESTO, P_CDFILIMOVI, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, ' ', ' ', '3',
                        'N', '9', P_CDTIPORETI, V_CUSTOPROD, ((V_QTESTOQDIA - C_ATUAINVENTOK.QTINVEROTA) * V_CUSTOPROD));

                        /* INSERE O ITEM DE RETIRADA */
                        INSERT INTO ITEMRETI
                        (CDFILIAL, NRRETIRADA, NRCARDAPIO, NRSEQUITRETI, CDPRODUTO,
                        QTRETIRADA, CDFIITLANEST, NRLANCESTQ, NRSEQUITEM, CDTIPORETI)
                        VALUES
                        (P_CDFILIMOVI, V_NRRETIRADA, V_NRCARDAPIO, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO,
                        (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVEROTA), C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), P_CDTIPORETI);
                     END IF;
                  ELSE
                     IF (C_ATUAINVENTOK.QTINVEROTA < V_QTESTOQDIA) THEN
                        IF ((V_NRLANCVER IS NULL) OR (V_NRLANCVER <> V_NRAJUSTE)) THEN
                           /* SE HOUVE MUDANCA DO AJUSTE */
                           IF (V_NRLANCVER IS NOT NULL) THEN
                              IF (P_EVOLEST = 'S') THEN
                                 /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTACAO ANTERIOR */
                                 FOR C_MOVIRET IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                                     FROM MOVILOTE
                                                    WHERE NRMOVILOTE = P_CDFILIAL || V_NRLANCESTRET) LOOP
                                    UPDATE ITLANCTOEST
                                       SET IDEVOLESTOQ = 'S'
                                     WHERE CDFILIAL = P_CDFILIAL
                                       AND NRLANCESTQ = V_NRLANCESTRET
                                       AND CDPRODUTO = C_MOVIRET.CDPRODUTO
                                       AND CDALMOXARIFE = C_MOVIRET.CDALMOXARIFE
                                       AND CDLOCALESTOQ = C_MOVIRET.CDLOCALESTOQ
                                       AND NRLOTEESTQ  = C_MOVIRET.NRLOTEESTQ
                                       AND NRSUBLOTE = C_MOVIRET.NRSUBLOTE;
                                 END LOOP;
                                 ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRLANCESTRET);
                              ELSE
                                 UPDATE ITLANCTOEST
                                    SET IDEVOLESTOQ = 'N'
                                  WHERE CDFILIAL = P_CDFILIAL
                                    AND NRLANCESTQ = V_NRLANCESTRET;
                              END IF;
                           END IF;

                           /* LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                           NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);
                           V_NRLANCESTRET := SUBSTR(V_NRLANCESTRET, 11, 20);

                           INSERT INTO LANCTOESTOQ
                           (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, CDOPERADOR, CDFILIMOVI)
                           VALUES
                           (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, '3', V_DTPOSESTDIA, 'Retirada para Ajuste', P_CDOPERADOR, P_CDFILIMOVI);

                           /* RETIRADA DE ESTOQUE */
                           NOVO_CODIGO('RETIESTO'||C_ATUAINVENTOK.CDFILIAL, V_NRRETIRADA);
                           V_NRRETIRADA := SUBSTR(V_NRRETIRADA, 11, 20);

                           INSERT INTO RETIRADAESTO
                           (CDFILIAL, NRRETEST, DTRETEST, DSRETEST, CDFILIALLAN, NRLANCESTQ, CDSETOR, CDCENTCUST, NRORDPROD, NRREQUESTO)
                           VALUES
                           (P_CDFILIMOVI, V_NRRETIRADA, V_DTPOSESTDIA, 'Retirada para Ajuste', C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, P_CDSETOR, P_CDCENTCUST, '', '');

                           /* RELACIONAMENTO AJUSTE/RETIRADA */
                           INSERT INTO AJURELACRET
                           (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                           VALUES
                           (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);

                           V_NRLANCVER := V_NRAJUSTE;
                        END IF;

                        /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                        INSERT INTO ITLANCTOEST
                        (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST,
                        QTTOTLANCTO, CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI,
                        IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO, CDCENTCUST)
                        VALUES
                        (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO, (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVEROTA),
                        (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVEROTA), V_CDPRODESTO, P_CDFILIMOVI, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, ' ', ' ', '3',
                        'N', '9', P_CDTIPORETI, V_CUSTOPROD, ((V_QTESTOQDIA - C_ATUAINVENTOK.QTINVEROTA) * V_CUSTOPROD), P_CDCENTCUST);
                     END IF;
                  END IF;
               END IF;

               /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - AJUSTE */
               INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
                   CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                   NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
                   VRTOTLANCTO, IDORDEMCLC)
               VALUES
                  (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO, V_QTINVROTA, C_ATUAINVENTOK.QTINVEROTA,
                   V_CDPRODESTO, 'N', P_CDFILIMOVI, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, ' ', ' ', V_TIPOMOV, V_CUSTOPROD, V_CUSTOPROD,
                   C_ATUAINVENTOK.DTINVEROTA, (V_CUSTOPROD * V_VRFATOCONV), (V_CUSTOPROD * C_ATUAINVENTOK.QTINVEROTA), V_IDORDEMCLC);

               /* ATUALIZA O INVENTARIO DO PRODUTO */
               UPDATE INVEROTA
                  SET IDINVENTOK = 'S'
                WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                  AND DTINVEROTA = C_ATUAINVENTOK.DTINVEROTA
                  AND CDALMOXARIFE = C_ATUAINVENTOK.CDALMOXARIFE
                  AND CDLOCALESTOQ = C_ATUAINVENTOK.CDLOCALESTOQ
                  AND CDPRODUTO = C_ATUAINVENTOK.CDPRODUTO;
            END IF;

            IF (V_IDCTRLESTQ <> 'N') THEN
               /* ATUALIZA REGISTRO DE PRODUTOS POR LOCAL DE ESTOQUE, SE A FILIAL CONTROLA ESTOQUE */
               INSERT INTO PRODLCESTOQ
               (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
               (SELECT C_ATUAINVENTOK.CDFILIAL, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, V_CDPRODESTO
                  FROM PRODFILI
                 WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                   AND CDPRODUTO = V_CDPRODESTO
                   AND NVL(IDCNTRESTOQ, 'S') <> 'N'
                 MINUS
                SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
                  FROM PRODLCESTOQ
                 WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                   AND CDALMOXARIFE = C_ATUAINVENTOK.CDALMOXARIFE
                   AND CDLOCALESTOQ = C_ATUAINVENTOK.CDLOCALESTOQ
                   AND CDPRODUTO = V_CDPRODESTO);
            END IF;
         END  LOOP;


         IF (V_NRAJUSTE IS NOT NULL)THEN
            IF (P_INOPCAO = 3 ) THEN
               /* SE A OPCAO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
               E QUE NAO ESTAO CADASTRADOS NO INVENTARIO, SERAO ZERADOS */
                FOR C_ZERAEST IN (SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
                                   FROM POSESTDIA A,
                                        (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                                           FROM POSESTDIA
                                          WHERE CDFILIAL = P_CDFILIAL
                                            AND CDALMOXARIFE = V_ALMOXARIF
                                            AND CDLOCALESTOQ = V_LOCALEST
                                            AND DTPOSIESTQ < V_DTMOVI
                                          GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
                                  WHERE A.CDFILIAL = P_CDFILIAL
                                    AND A.CDALMOXARIFE = V_ALMOXARIF
                                    AND A.CDLOCALESTOQ = V_LOCALEST
                                    AND A.CDFILIAL = X.CDFILIAL
                                    AND A.CDPRODUTO = X.CDPRODUTO
                                    AND A.CDALMOXARIFE = X.CDALMOXARIFE
                                    AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                                    AND A.NRLOTEESTQ = X.NRLOTEESTQ
                                    AND A.NRSUBLOTE = X.NRSUBLOTE
                                    AND A.DTPOSIESTQ = X.DTPOSIESTQ
                                    AND A.QTESTOQDIA <> 0
                                    AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO
                                                      FROM INVEROTA I,
                                                           (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                                                              FROM INVEROTA
                                                             WHERE CDFILIAL = P_CDFILIAL
                                                               AND CDALMOXARIFE = V_ALMOXARIF
                                                               AND CDLOCALESTOQ = V_LOCALEST
                                                               AND DTINVEROTA < V_DTMOVI
                                                             GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) B
                                                     WHERE I.CDFILIAL = P_CDFILIAL
                                                       AND I.CDALMOXARIFE = V_ALMOXARIF
                                                       AND I.CDLOCALESTOQ = V_LOCALEST
                                                       AND I.CDFILIAL = B.CDFILIAL
                                                       AND I.CDPRODUTO = B.CDPRODUTO
                                                       AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                                       AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                                       AND I.DTINVEROTA = B.DTINVEROTA
                                                       AND A.CDFILIAL = I.CDFILIAL
                                                       AND A.CDPRODUTO = I.CDPRODUTO
                                                       AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                                       and a.cdlocalestoq = i.cdlocalestoq)) loop

                  IF (V_NRSEQAJU = 9999) THEN
                     IF (P_EVOLEST = 'S') THEN
                        FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                             FROM MOVILOTE
                                            WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ = 'S'
                            WHERE CDFILIAL = P_CDFILIAL
                              AND NRLANCESTQ = V_NRAJUSTE
                              AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                              AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                              AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                              AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                              AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                        END LOOP;
                        ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);
                     ELSE
                        UPDATE ITLANCTOEST
                           SET IDEVOLESTOQ = 'N'
                         WHERE CDFILIAL = P_CDFILIAL
                           AND NRLANCESTQ = V_NRAJUSTE;
                     END IF;

                     NOVO_CODIGO('LANCTOEST'||P_CDFILIAL, V_NRAJUSTE);
                     V_NRAJUSTE := SUBSTR(V_NRAJUSTE, 11, 20);

                     INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                     VALUES (P_CDFILIAL, V_NRAJUSTE, V_TIPOMOV, V_DTMOVI, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);

                     V_NRSEQAJU := 0;
                  END IF;

                  V_NRSEQAJU := V_NRSEQAJU + 1;

                  INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE,
                  CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                  VALUES
                  (P_CDFILIAL, V_NRAJUSTE, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ZERAEST.CDPRODUTO, 0, 0, C_ZERAEST.CDPRODUTO, 'N', P_CDFILIMOVI, C_ZERAEST.CDALMOXARIFE,
                  C_ZERAEST.CDLOCALESTOQ, C_ZERAEST.NRLOTEESTQ, C_ZERAEST.NRSUBLOTE, '1', 0, 0, V_DTMOVI, 0, 0, V_IDORDEMCLC);

                  UPDATE (SELECT E.*
                            FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                          AND E.NRLANCTONF  = I.NRLANCTONF
                                                                          AND E.NRSEQITPROD = I.NRSEQITPROD
                           WHERE I.CDFILIMOVI   = P_CDFILIMOVI
                             AND I.CDPRODUTO    = C_ZERAEST.CDPRODUTO
                             AND I.CDALMOXARIFE = C_ZERAEST.CDALMOXARIFE
                             AND I.NRLOTEESTQ   = C_ZERAEST.NRLOTEESTQ
                             AND I.CDLOCALESTOQ = C_ZERAEST.CDLOCALESTOQ
                             AND I.NRSUBLOTE    = C_ZERAEST.NRSUBLOTE
                             AND E.IDSTATUSETIQ <> 'I')
                     SET IDSTATUSETIQ = 'I',
                         DSNOTAFISORIGET = 'INV '||TO_CHAR(SYSDATE, 'DD/MM/YYYY');
               END LOOP;
            END IF;

            IF (P_EVOLEST = 'S') THEN
               /* ATUALIZA A ULTIMA MOVIMENTACAO DE AJUSTE E MOVIMENTACAO DE RETIRADA NO ESTOQUE */
               FOR C_MOVIAJU IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                   FROM MOVILOTE
                                  WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ = 'S'
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NRLANCESTQ = V_NRAJUSTE
                     AND CDPRODUTO = C_MOVIAJU.CDPRODUTO
                     AND CDALMOXARIFE = C_MOVIAJU.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_MOVIAJU.CDLOCALESTOQ
                     AND NRLOTEESTQ  = C_MOVIAJU.NRLOTEESTQ
                     AND NRSUBLOTE = C_MOVIAJU.NRSUBLOTE;
               END LOOP;
               ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);

               IF (V_IDGERARETAJU = 'S') THEN
                  FOR C_MOVIRET IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                      FROM MOVILOTE
                                     WHERE NRMOVILOTE = P_CDFILIAL || V_NRLANCESTRET) LOOP
                     UPDATE ITLANCTOEST
                        SET IDEVOLESTOQ = 'S'
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NRLANCESTQ = V_NRLANCESTRET
                        AND CDPRODUTO = C_MOVIRET.CDPRODUTO
                        AND CDALMOXARIFE = C_MOVIRET.CDALMOXARIFE
                        AND CDLOCALESTOQ = C_MOVIRET.CDLOCALESTOQ
                        AND NRLOTEESTQ  = C_MOVIRET.NRLOTEESTQ
                        AND NRSUBLOTE = C_MOVIRET.NRSUBLOTE;
                  END LOOP;
                  ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRLANCESTRET);
               END IF;
            ELSE
               UPDATE ITLANCTOEST
                  SET IDEVOLESTOQ = 'N'
                WHERE CDFILIAL = P_CDFILIAL
                  AND NRLANCESTQ = V_NRAJUSTE;
               IF (V_IDGERARETAJU = 'S') THEN
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ = 'N'
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NRLANCESTQ = V_NRLANCESTRET;
               END IF;
            END IF;
         END IF;
         /*    INCLUSAO DE IMPLANTACAO DE ESTOQUE     */
         V_ALMOXARIF := 'NOVO';
         V_LOCALEST  := 'NOVO';
         FOR C_ATUAIMP IN C_INVENTOK LOOP
            SELECT CDPRODESTO, VRFATOCONV
              INTO V_CDPRODESTO, V_VRFATOCONV
              FROM PRODUTO
             WHERE CDPRODUTO = C_ATUAIMP.CDPRODUTO;

            V_CUSTOPROD := CUSTO_PRODUTO_LCEST(C_ATUAIMP.CDFILIAL, V_CDPRODESTO, 3, P_DATAPROC, SYSDATE,
                                               C_ATUAIMP.CDALMOXARIFE, C_ATUAIMP.CDLOCALESTOQ, ' ', ' ');

            IF (V_CUSTOPROD IS NULL) THEN
               V_CUSTOPROD := 0;
            ELSE
               V_CUSTOPROD := V_CUSTOPROD * V_VRFATOCONV;
            END IF;

            IF (C_ATUAIMP.QTESTOQUE = 0) THEN
               V_QTESTOQDIA := C_ATUAIMP.QTESTOQUE;
            ELSE
               V_QTESTOQDIA := C_ATUAIMP.QTESTOQUE / V_VRFATOCONV;
            END IF;

            IF (V_VRFATOCONV = 1) THEN
               V_QTINVROTA := C_ATUAIMP.QTINVEROTA;
            ELSE
               V_QTINVROTA := C_ATUAIMP.QTINVEROTA * V_VRFATOCONV;
            END IF;

            IF (V_IDORDAJUINVE = 'U') THEN
               V_DTPOSESTDIA := C_ATUAIMP.DTINVEROTA ;
            ELSE
               V_DTPOSESTDIA := C_ATUAIMP.DTINVEROTA - 1;
            END IF;

            V_TIPOMOV := '0';

            IF ((V_ALMOXARIF <> C_ATUAIMP.CDALMOXARIFE) OR (V_LOCALEST <> C_ATUAIMP.CDLOCALESTOQ) OR (V_NRSEQIMP = 9999)) THEN
               V_ALMOXARIF := C_ATUAIMP.CDALMOXARIFE;
               V_LOCALEST := C_ATUAIMP.CDLOCALESTOQ;

               IF (V_NRIMPLANTA IS NOT NULL) THEN
                  IF (P_EVOLEST = 'S') THEN
                     FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                          FROM MOVILOTE
                                         WHERE NRMOVILOTE = P_CDFILIAL || V_NRIMPLANTA) LOOP
                        UPDATE ITLANCTOEST
                           SET IDEVOLESTOQ = 'S'
                         WHERE CDFILIAL = P_CDFILIAL
                           AND NRLANCESTQ = V_NRIMPLANTA
                           AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                           AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                           AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                           AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                           AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                     END LOOP;
                     ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRIMPLANTA);
                  ELSE
                     UPDATE ITLANCTOEST
                        SET IDEVOLESTOQ = 'N'
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NRLANCESTQ = V_NRIMPLANTA;
                  END IF;
               END IF;

               NOVO_CODIGO('LANCTOEST'||C_ATUAIMP.CDFILIAL, V_NRIMPLANTA);
               V_NRIMPLANTA := SUBSTR(V_NRIMPLANTA, 11, 20);

               V_DESCALMOX := 'Implantacao para Inventario Rotativo';
               IF (V_IDUTILALMOX = 'S') THEN
                  V_DESCALMOX := V_DESCALMOX||' - Almox. '||C_ATUAIMP.CDALMOXARIFE;
                  IF (V_IDUTILLCESTQ = 'S') THEN
                     V_DESCALMOX := V_DESCALMOX||' Local. '||C_ATUAIMP.CDLOCALESTOQ;
                  END IF;
               END IF;

               /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - IMPLANTACAO */
               INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
               VALUES (C_ATUAIMP.CDFILIAL, V_NRIMPLANTA, V_TIPOMOV, C_ATUAIMP.DTINVEROTA, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);

               V_NRSEQIMP := 0;
            END IF;

            V_NRSEQIMP := V_NRSEQIMP + 1;

            /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - IMPLANTACAO */
            INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
            CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
            NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
            VRTOTLANCTO, IDORDEMCLC)
            VALUES
            (C_ATUAIMP.CDFILIAL, V_NRIMPLANTA, LPAD(TO_CHAR(V_NRSEQIMP),4,'0'), C_ATUAIMP.CDPRODUTO, V_QTINVROTA, C_ATUAIMP.QTINVEROTA,
            V_CDPRODESTO, 'N', P_CDFILIMOVI, C_ATUAIMP.CDALMOXARIFE, C_ATUAIMP.CDLOCALESTOQ, ' ', ' ', V_TIPOMOV, V_CUSTOPROD, V_CUSTOPROD,
            C_ATUAIMP.DTINVEROTA, (V_CUSTOPROD * V_VRFATOCONV), (V_CUSTOPROD * C_ATUAIMP.QTINVEROTA), V_IDORDEMCLC);

            /* ATUALIZA O INVENTARIO DO PRODUTO */
            UPDATE INVEROTA
               SET IDINVENTOK = 'S'
             WHERE CDFILIAL = C_ATUAIMP.CDFILIAL
               AND DTINVEROTA = C_ATUAIMP.DTINVEROTA
               AND CDALMOXARIFE = C_ATUAIMP.CDALMOXARIFE
               AND CDLOCALESTOQ = C_ATUAIMP.CDLOCALESTOQ
               AND CDPRODUTO = C_ATUAIMP.CDPRODUTO;
         END LOOP;

         IF (V_NRIMPLANTA IS NOT NULL) THEN
            IF (P_EVOLEST = 'S') THEN
               FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                   FROM MOVILOTE
                                   WHERE NRMOVILOTE = P_CDFILIAL || V_NRIMPLANTA) LOOP
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ = 'S'
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NRLANCESTQ = V_NRIMPLANTA
                     AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                     AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                     AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                     AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
               END LOOP;
               ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRIMPLANTA);
            ELSE
               UPDATE ITLANCTOEST
                  set idevolestoq = 'N'
                where cdfilial    = p_cdfilial
                  AND NRLANCESTQ  = V_NRIMPLANTA;
            END IF;
         END IF;
      ELSE
      /* INVENTARIO ROTATIVO POR LOTE */
      /* INICIO */
      /* INCLUSAO DE AJUSTE E DE RETIRADA */
        IF P_INOPCAO = 10 OR P_INOPCAO = 12 THEN
          FOR C_VERIFESTOQUE IN C_INVLOTEOK LOOP
            BEGIN
              SELECT
                SUM(A.QTLANCTOEST)
              INTO
                V_QTLANCSAID
              FROM
                ITLANCTOEST A, PRODUTO B
              WHERE
                (A.CDFILIMOVI    = P_CDFILIMOVI)   AND
                (A.CDPRODUTO     = C_VERIFESTOQUE.CDPRODUTO) AND
                (B.CDPRODUTO     = A.CDPRODUTO) AND
                (A.CDALMOXARIFE  = C_VERIFESTOQUE.CDALMOXARIFE) AND
                (A.CDLOCALESTOQ  = C_VERIFESTOQUE.CDLOCALESTOQ ) AND
                (A.IDTIPOMOVI IN ('3','4'))     AND
                (A.DTLANCMOVI BETWEEN P_DATAPROC    AND  SYSDATE + (SELECT
                                                                  (DECODE(NRDIASSAIDPDFIL,NULL,
                                                                  (SELECT NRDIASSAIDPD FROM PARAMESTOQUE ),NRDIASSAIDPDFIL)) AS NRDIASSAIDA
                                                                FROM
                                                                    PARAMFILIAL
                                                                WHERE
                                                                    CDFILIAL = P_CDFILIMOVI));
            EXCEPTION
              WHEN NO_DATA_FOUND THEN BEGIN
                V_QTLANCSAID := 0;
              END;
            END;

            IF (V_QTLANCSAID  > C_VERIFESTOQUE.QTINVELOTE)THEN
              V_NRITEMIRREG := V_NRITEMIRREG +1;
              INSERT INTO TRAB_IRREG_EST (NRLANCIRREST,
                                          NRITEMIRREG,
                                          CDFILIAL,
                                          CDPRODUTO,
                                          NMPRODUTO,
                                          CDALMOXARIFE,
                                          CDLOCALESTOQ,
                                          NRLOTEESTQ,
                                          NRSUBLOTE,
                                          QTINVEROTA,
                                          QTLANCSAID)
              VALUES (V_NRLANCIRREST,
                      V_NRITEMIRREG,
                      C_VERIFESTOQUE.CDFILIAL,
                      C_VERIFESTOQUE.CDPRODUTO,
                      C_VERIFESTOQUE.NMPRODUTO,
                      C_VERIFESTOQUE.CDALMOXARIFE,
                      C_VERIFESTOQUE.CDLOCALESTOQ,
                      C_VERIFESTOQUE.NRLOTEESTQ,
                      C_VERIFESTOQUE.NRSUBLOTE,
                      C_VERIFESTOQUE.QTINVELOTE,
                      V_QTLANCSAID);
              V_COUNTIRREG := V_COUNTIRREG +1 ;
              COMMIT;
            END IF;
          END LOOP;

          IF (V_COUNTIRREG  > 0) THEN
            RAISE_APPLICATION_ERROR(-20502,V_NRLANCIRREST, FALSE);
          END IF;
        END IF;
        FOR C_ATUAINVENTOK IN C_INVLOTEOK LOOP
           SELECT CDPRODESTO, VRFATOCONV
             INTO V_CDPRODESTO, V_VRFATOCONV
             FROM PRODUTO
            WHERE CDPRODUTO = C_ATUAINVENTOK.CDPRODUTO;

           V_CUSTOPROD := CUSTO_PRODUTO_LCEST(C_ATUAINVENTOK.CDFILIAL, V_CDPRODESTO, 3, C_ATUAINVENTOK.DTINVELOTE, SYSDATE, C_ATUAINVENTOK.CDALMOXARIFE,
                                              C_ATUAINVENTOK.CDLOCALESTOQ, C_ATUAINVENTOK.NRLOTEESTQ, C_ATUAINVENTOK.NRSUBLOTE);

           IF (V_CUSTOPROD IS NULL) THEN
              V_CUSTOPROD := 0;
           ELSE
              V_CUSTOPROD := V_CUSTOPROD * V_VRFATOCONV;
           END IF;

           IF (C_ATUAINVENTOK.QTESTOLOTE = 0) THEN
              V_QTESTOQDIA := C_ATUAINVENTOK.QTESTOLOTE;
           ELSE
              V_QTESTOQDIA := C_ATUAINVENTOK.QTESTOLOTE / V_VRFATOCONV;
           END IF;

           IF (V_VRFATOCONV = 1) THEN
              V_QTINVROTA := C_ATUAINVENTOK.QTINVELOTE;
           ELSE
              V_QTINVROTA := C_ATUAINVENTOK.QTINVELOTE * V_VRFATOCONV;
           END IF;

           IF (V_IDORDAJUINVE = 'U') THEN
              V_DTPOSESTDIA := C_ATUAINVENTOK.DTINVELOTE ;
           ELSE
              V_DTPOSESTDIA := C_ATUAINVENTOK.DTINVELOTE - 1;
           END IF;

           IF (V_CUSTOPROD > 0) THEN
              V_TIPOMOV := '1';
              /* CASO HAJA UMA MUDANCA DE ALMOXARIFADO OU LOCALIZACAO, SERA INCLUIDO UM NOVO AJUSTE */
              IF ((V_ALMOXARIF <> C_ATUAINVENTOK.CDALMOXARIFE) OR (V_LOCALEST <> C_ATUAINVENTOK.CDLOCALESTOQ) OR (V_NRSEQAJU = 9999)) THEN
                 IF (V_NRAJUSTE IS NOT NULL) THEN
                    IF ((P_INOPCAO = 3 ) AND ((V_ALMOXARIF <> C_ATUAINVENTOK.CDALMOXARIFE) OR (V_LOCALEST <> C_ATUAINVENTOK.CDLOCALESTOQ)))THEN
                       /* SE A OPCAO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
                       E QUE NAO ESTAO CADASTRADOS NO INVENTARIO, SERAO ZERADOS */
                       FOR C_ZERAEST IN (SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
                                           FROM POSESTDIA A,
                                           (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                                              FROM POSESTDIA
                                             WHERE CDFILIAL = P_CDFILIAL
                                               AND CDALMOXARIFE = V_ALMOXARIF
                                               AND CDLOCALESTOQ = V_LOCALEST
                                               AND DTPOSIESTQ < V_DTMOVI
                                             GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
                                         WHERE A.CDFILIAL = P_CDFILIAL
                                           AND A.CDALMOXARIFE = V_ALMOXARIF
                                           AND A.CDLOCALESTOQ = V_LOCALEST
                                           AND A.CDFILIAL = X.CDFILIAL
                                           AND A.CDPRODUTO = X.CDPRODUTO
                                           AND A.CDALMOXARIFE = X.CDALMOXARIFE
                                           AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                                           AND A.NRLOTEESTQ = X.NRLOTEESTQ
                                           AND A.NRSUBLOTE = X.NRSUBLOTE
                                           AND A.DTPOSIESTQ = X.DTPOSIESTQ
                                           AND A.QTESTOQDIA <> 0
                                           AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE
                                                             FROM INVEROTALOTE I,
                                                              (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                                                                 FROM INVEROTALOTE
                                                                WHERE CDFILIAL = P_CDFILIAL
                                                                  AND CDALMOXARIFE = V_ALMOXARIF
                                                                  AND CDLOCALESTOQ = V_LOCALEST
                                                                  AND DTINVELOTE < V_DTMOVI
                                                                GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) B
                                                        WHERE I.CDFILIAL = P_CDFILIAL
                                                          AND I.CDALMOXARIFE = V_ALMOXARIF
                                                          AND I.CDLOCALESTOQ = V_LOCALEST
                                                          AND I.CDFILIAL = B.CDFILIAL
                                                          AND I.CDPRODUTO = B.CDPRODUTO
                                                          AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                                          AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                                          AND I.NRLOTEESTQ = B.NRLOTEESTQ
                                                          AND I.NRSUBLOTE = B.NRSUBLOTE
                                                          AND I.DTINVELOTE = B.DTINVELOTE
                                                          AND A.CDFILIAL = I.CDFILIAL
                                                          AND A.CDPRODUTO = I.CDPRODUTO
                                                          AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                                          AND A.CDLOCALESTOQ = I.CDLOCALESTOQ
                                                          AND A.NRLOTEESTQ = I.NRLOTEESTQ
                                                          AND A.NRSUBLOTE = I.NRSUBLOTE)) LOOP
                     IF (V_NRSEQAJU = 9999) THEN
                        IF (P_EVOLEST = 'S') THEN
                           FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                                FROM MOVILOTE
                                               WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                              UPDATE ITLANCTOEST
                                 SET IDEVOLESTOQ = 'S'
                               WHERE CDFILIAL = P_CDFILIAL
                                 AND NRLANCESTQ = V_NRAJUSTE
                                 AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                                 AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                                 AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                                 AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                                 AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                           END LOOP;
                           ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);
                        ELSE
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ = 'N'
                            WHERE CDFILIAL = P_CDFILIAL
                              AND NRLANCESTQ = V_NRAJUSTE;
                        END IF;

                        NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE);
                        V_NRAJUSTE := SUBSTR(V_NRAJUSTE, 11, 20);

                        INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                        VALUES (P_CDFILIAL, V_NRAJUSTE, V_TIPOMOV, V_DTMOVI, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);
                        V_NRSEQAJU := 0;
                     END IF;

                     V_NRSEQAJU := V_NRSEQAJU + 1;

                     INSERT INTO ITLANCTOEST
                     (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE,
                     CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                     VALUES
                     (P_CDFILIAL, V_NRAJUSTE, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ZERAEST.CDPRODUTO, 0, 0, C_ZERAEST.CDPRODUTO, 'N', P_CDFILIMOVI, C_ZERAEST.CDALMOXARIFE,
                     C_ZERAEST.CDLOCALESTOQ, C_ZERAEST.NRLOTEESTQ, C_ZERAEST.NRSUBLOTE, '1', 0, 0, V_DTMOVI, 0, 0, V_IDORDEMCLC);
                                       
                     UPDATE (SELECT E.*
                               FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                             AND E.NRLANCTONF  = I.NRLANCTONF
                                                                             AND E.NRSEQITPROD = I.NRSEQITPROD
                              WHERE I.CDFILIMOVI   = P_CDFILIMOVI
                                AND I.CDPRODUTO    = C_ZERAEST.CDPRODUTO
                                AND I.CDALMOXARIFE = C_ZERAEST.CDALMOXARIFE
                                AND I.NRLOTEESTQ   = C_ZERAEST.NRLOTEESTQ
                                AND I.CDLOCALESTOQ = C_ZERAEST.CDLOCALESTOQ
                                AND I.NRSUBLOTE    = C_ZERAEST.NRSUBLOTE
                                AND E.IDSTATUSETIQ <> 'I')
                        SET IDSTATUSETIQ = 'I',
                            DSNOTAFISORIGET = 'INV '||TO_CHAR(SYSDATE, 'DD/MM/YYYY');
                  END LOOP;
                END IF;
                /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZACAO ANTERIOR */
                IF (P_EVOLEST = 'S') THEN
                  FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                       FROM MOVILOTE
                                      WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                     UPDATE ITLANCTOEST
                        SET IDEVOLESTOQ = 'N'
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NRLANCESTQ = V_NRAJUSTE
                        AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                        AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                        AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                        AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                        AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                  END LOOP;
                  ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);
                ELSE
                  UPDATE ITLANCTOEST
                    SET IDEVOLESTOQ = 'N'
                  WHERE CDFILIAL = P_CDFILIAL
                    AND NRLANCESTQ = V_NRAJUSTE;
                  END IF;
                END IF;

                V_ALMOXARIF := C_ATUAINVENTOK.CDALMOXARIFE;
                V_LOCALEST := C_ATUAINVENTOK.CDLOCALESTOQ;
                V_DTMOVI := C_ATUAINVENTOK.DTINVELOTE;

                NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE);
                V_NRAJUSTE := SUBSTR(V_NRAJUSTE, 11, 20);
                V_DESCALMOX := 'Ajuste para Inventario Rotativo';
                IF (V_IDUTILALMOX = 'S') THEN
                  V_DESCALMOX := V_DESCALMOX||' - Almox. '||C_ATUAINVENTOK.CDALMOXARIFE;
                END IF;
                IF (V_IDUTILLCESTQ = 'S') THEN
                  V_DESCALMOX := V_DESCALMOX||' Local. '||C_ATUAINVENTOK.CDLOCALESTOQ;
                END IF;

                /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - AJUSTE */
                INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                VALUES (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, V_TIPOMOV, C_ATUAINVENTOK.DTINVELOTE, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);
                V_NRSEQAJU := 0;
          END IF;

          V_NRSEQAJU := V_NRSEQAJU + 1;

          IF (V_IDGERARETAJU = 'S') THEN
            /* SE ESTA PARAMETRIZADO PARA REALIZAR RETIRADA AO REALIZAR AJUSTE NO ESTOQUE */
            IF (P_RETIESTQ <> 'S') THEN
              /* SE A RETIRADA E POR SERVICO */
              IF ((P_CDSERVFILI IS NOT NULL) AND (C_ATUAINVENTOK.QTINVELOTE < V_QTESTOQDIA)) THEN
                /* SE O SERVICO FOI INFORMADO E SE A QUANTIDADE DO INVENTARIO E MENOR QUE A QUANTIDADE EM ESTOQUE */
                IF ((V_NRLANCVER IS NULL) OR (V_NRLANCVER <> V_NRAJUSTE)) THEN
                  /* VERIFICA SE HOUVE MUDANCA DE LANCAMENTO DE AJUSTE */
                  IF (V_NRLANCVER IS NOT NULL) THEN
                    /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTACAO ANTERIOR */
                    IF (P_EVOLEST = 'S') THEN
                      FOR C_MOVIRET IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                               FROM MOVILOTE
                                              WHERE NRMOVILOTE = P_CDFILIAL || V_NRLANCESTRET) LOOP
                              UPDATE ITLANCTOEST
                                 SET IDEVOLESTOQ = 'N'
                               WHERE CDFILIAL = P_CDFILIAL
                                 AND NRLANCESTQ = V_NRLANCESTRET
                                 AND CDPRODUTO = C_MOVIRET.CDPRODUTO
                                 AND CDALMOXARIFE = C_MOVIRET.CDALMOXARIFE
                                 AND CDLOCALESTOQ = C_MOVIRET.CDLOCALESTOQ
                                 AND NRLOTEESTQ  = C_MOVIRET.NRLOTEESTQ
                                 AND NRSUBLOTE = C_MOVIRET.NRSUBLOTE;
                           END LOOP;
                           ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRLANCESTRET);
                    ELSE
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ = 'N'
                            WHERE CDFILIAL = P_CDFILIAL
                              AND NRLANCESTQ = V_NRLANCESTRET;
                    END IF;
                  END IF;
                     /* CARREGA AS INFORMACOES DA RETIRADA, DO CARDAPIO E DA RETIRADA DE ESTOQUE REFERENTES AO AJUSTE INFORMADO */
                  BEGIN
                    SELECT
                      AR.NRLANCESTRET, RE.NRRETIRADA, CD.NRCARDAPIO
                    INTO
                      V_NRLANCESTRET, V_NRRETIRADA, V_NRCARDAPIO
                    FROM
                      CARDADIA CD, RETIRADA RE, AJURELACRET AR
                    WHERE
                      CD.NRCARDAPIO = RE.NRCARDAPIO
                      AND CD.CDFILIAL = RE.CDFILIAL
                      AND RE.NRLANCESTQ = AR.NRLANCESTRET
                      AND RE.CDFILANCESTQ = AR.CDFILIAL
                      AND AR.CDFILIALRET = C_ATUAINVENTOK.CDFILIAL
                      AND AR.NRLANCESTQ = V_NRAJUSTE
                      AND AR.CDFILIAL = C_ATUAINVENTOK.CDFILIAL;
                  EXCEPTION
                    WHEN NO_DATA_FOUND THEN BEGIN
                      V_NRLANCESTRET := '';
                      V_NRRETIRADA := '';
                      V_NRCARDAPIO := '';
                    END;
                  END;

                  IF ((V_NRLANCESTRET IS NULL) AND (V_NRRETIRADA IS NULL) AND (V_NRCARDAPIO IS NULL)) THEN
                        /* CASO NAO TENHA INFORMACOES DE RETIRADA CADASTRADAS */

                        /* LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                        NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);
                        V_NRLANCESTRET := SUBSTR(V_NRLANCESTRET, 11, 20);

                        INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                        VALUES (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, '3', V_DTPOSESTDIA, P_CDFILIMOVI, P_CDOPERADOR, 'Retirada para Ajuste : '||V_NRAJUSTE);

                        /* CARDAPIO */
                        /* VERIFICA A EXISTENCIA DE CARDAPIO */
                        BEGIN
                           SELECT NRCARDAPIO
                             INTO V_NRCARDAPIO
                             FROM CARDADIA
                            WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                              AND CDSERVFILI = P_CDSERVFILI
                              AND DTCARDAPIO = V_DTPOSESTDIA;
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN BEGIN
                              V_NRCARDAPIO := '';
                           END;
                        END;

                        IF (V_NRCARDAPIO IS NULL) THEN
                           /* SE NAO EXISTIR CARDAPIO, SERA INCLUIDO UM NOVO */
                           NOVO_CODIGO('CARDAPIO'||C_ATUAINVENTOK.CDFILIAL, V_NRCARDAPIO);
                           V_NRCARDAPIO := SUBSTR(V_NRCARDAPIO, 11, 20);

                           INSERT INTO CARDADIA
                           (CDFILIAL, NRCARDAPIO, CDSERVFILI, CDOPERADOR, DTCARDAPIO, DTMESCARD)
                           VALUES
                           (C_ATUAINVENTOK.CDFILIAL, V_NRCARDAPIO, P_CDSERVFILI, P_CDOPERADOR, V_DTPOSESTDIA, TO_DATE('01/'||TO_CHAR(V_DTPOSESTDIA,'MM/YYYY')));
                        END IF;

                        /* RETIRADA */
                        NOVO_CODIGO('RETIRADA'||C_ATUAINVENTOK.CDFILIAL, V_NRRETIRADA);
                        V_NRRETIRADA := SUBSTR(V_NRRETIRADA, 11, 20);

                        INSERT INTO RETIRADA
                        (CDFILIAL, NRRETIRADA, NRCARDAPIO, DTRETIRADA, CDFILANCESTQ, NRLANCESTQ)
                        VALUES
                        (P_CDFILIMOVI, V_NRRETIRADA, V_NRCARDAPIO, V_DTPOSESTDIA, C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);

                        /* RELACIONAMENTO AJUSTE/RETIRADA */
                        INSERT INTO AJURELACRET
                        (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                        VALUES
                        (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);
                     END IF;

                     /* VERIFICA SE O LANCAMENTO DE RETIRADA DE ESTOQUE POSSUI REGISTRO (A AVALIAR)*/
                     SELECT COUNT(*)
                       INTO V_CONTADOR
                       FROM ITLANCTOEST
                      WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                        AND NRLANCESTQ = V_NRLANCESTRET;

                     IF V_CONTADOR > 0 THEN
                        /* CASO EXISTA REGISTROS, ESSES REGISTROS SERAO DELETADOS (A AVALIAR) */
                        DELETE FROM ITEMRETI
                         WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                           AND NRRETIRADA = V_NRRETIRADA
                           AND NRCARDAPIO = V_NRCARDAPIO;

                        DELETE FROM ITLANCTOEST
                         WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
                           AND NRLANCESTQ = V_NRLANCESTRET;
                     END IF;

                     V_NRLANCVER := V_NRAJUSTE;
                  END IF;
                  /* NESTE LOCAL DA TELA TEM UMA VERIFICACAO NA TELA DE INVENTARIO QUE, CASO O LANCAMENTO DE ESTOQUE - RETIRADA TENHA
                     ALGUM ITEM CADASTRADO NAQUELA POSICAO DE ITEM, SERA DELETADO PARA INSERIR UM NOVO REGISTRO NESTA POSICAO (A VERIFICAR) */

                  /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                  INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
                  CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                  IDTIPOMOVI, IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO)
                  VALUES
                  (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO, (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVELOTE),
                  (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVELOTE), V_CDPRODESTO, P_CDFILIMOVI, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, C_ATUAINVENTOK.NRLOTEESTQ,
                  C_ATUAINVENTOK.NRSUBLOTE, '3', 'N', '9', P_CDTIPORETI, V_CUSTOPROD, ((V_QTESTOQDIA - C_ATUAINVENTOK.QTINVELOTE) * V_CUSTOPROD));

                  /* INSERE O ITEM DE RETIRADA */
                  INSERT INTO ITEMRETI
                  (CDFILIAL, NRRETIRADA, NRCARDAPIO, NRSEQUITRETI, CDPRODUTO,
                  QTRETIRADA, CDFIITLANEST, NRLANCESTQ, NRSEQUITEM, CDTIPORETI)
                  VALUES
                  (P_CDFILIMOVI, V_NRRETIRADA, V_NRCARDAPIO, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO,
                  (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVELOTE), C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), P_CDTIPORETI);
              END IF;
            ELSE
               IF (C_ATUAINVENTOK.QTINVELOTE < V_QTESTOQDIA) THEN
                  IF ((V_NRLANCVER IS NULL) OR (V_NRLANCVER <> V_NRAJUSTE)) THEN
                     /* SE HOUVE MUDANCA DO AJUSTE */
                     IF (V_NRLANCVER IS NOT NULL) THEN
                        IF (P_EVOLEST = 'S') THEN
                           /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTACAO ANTERIOR */
                           FOR C_MOVIRET IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                               FROM MOVILOTE
                                              WHERE NRMOVILOTE = P_CDFILIAL || V_NRLANCESTRET) LOOP
                              UPDATE ITLANCTOEST
                                 SET IDEVOLESTOQ = 'S'
                               WHERE CDFILIAL = P_CDFILIAL
                                 AND NRLANCESTQ = V_NRLANCESTRET
                                 AND CDPRODUTO = C_MOVIRET.CDPRODUTO
                                 AND CDALMOXARIFE = C_MOVIRET.CDALMOXARIFE
                                 AND CDLOCALESTOQ = C_MOVIRET.CDLOCALESTOQ
                                 AND NRLOTEESTQ  = C_MOVIRET.NRLOTEESTQ
                                 AND NRSUBLOTE = C_MOVIRET.NRSUBLOTE;
                           END LOOP;
                           ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRLANCESTRET);
                        ELSE
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ = 'N'
                            WHERE CDFILIAL = P_CDFILIAL
                              AND NRLANCESTQ = V_NRLANCESTRET;
                        END IF;
                     END IF;

                     /* LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                     NOVO_CODIGO('LANCTOEST'||C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);
                     V_NRLANCESTRET := SUBSTR(V_NRLANCESTRET, 11, 20);

                     INSERT INTO LANCTOESTOQ
                     (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, CDOPERADOR, CDFILIMOVI)
                     VALUES
                     (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, '3', V_DTPOSESTDIA, 'Retirada para Ajuste', P_CDOPERADOR, P_CDFILIMOVI);

                     /* RETIRADA DE ESTOQUE */
                     NOVO_CODIGO('RETIESTO'||C_ATUAINVENTOK.CDFILIAL, V_NRRETIRADA);
                     V_NRRETIRADA := SUBSTR(V_NRRETIRADA, 11, 20);

                     INSERT INTO RETIRADAESTO
                     (CDFILIAL, NRRETEST, DTRETEST, DSRETEST, CDFILIALLAN, NRLANCESTQ, CDSETOR, CDCENTCUST, NRORDPROD, NRREQUESTO)
                     VALUES
                     (P_CDFILIMOVI, V_NRRETIRADA, V_DTPOSESTDIA, 'Retirada para Ajuste', C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, P_CDSETOR, P_CDCENTCUST, '', '');

                     /* RELACIONAMENTO AJUSTE/RETIRADA */
                     INSERT INTO AJURELACRET
                     (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                     VALUES
                     (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET);

                     V_NRLANCVER := V_NRAJUSTE;
                  END IF;

                  /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - RETIRADA */
                  INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST,
                  QTTOTLANCTO, CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
                  NRSUBLOTE, IDTIPOMOVI, IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO, CDCENTCUST)
                  VALUES
                  (C_ATUAINVENTOK.CDFILIAL, V_NRLANCESTRET, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO, (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVELOTE),
                  (V_QTESTOQDIA - C_ATUAINVENTOK.QTINVELOTE), V_CDPRODESTO, P_CDFILIMOVI, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, C_ATUAINVENTOK.NRLOTEESTQ,
                  C_ATUAINVENTOK.NRSUBLOTE, '3', 'N', '9', P_CDTIPORETI, V_CUSTOPROD, ((V_QTESTOQDIA - C_ATUAINVENTOK.QTINVELOTE) * V_CUSTOPROD), P_CDCENTCUST);
              END IF;
            END IF;
          END IF;

          /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - AJUSTE */
          INSERT INTO ITLANCTOEST
             (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
              CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
              NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
              VRTOTLANCTO, IDORDEMCLC)
          VALUES
             (C_ATUAINVENTOK.CDFILIAL, V_NRAJUSTE, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ATUAINVENTOK.CDPRODUTO, V_QTINVROTA, C_ATUAINVENTOK.QTINVELOTE,
              V_CDPRODESTO, 'N', P_CDFILIMOVI, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, C_ATUAINVENTOK.NRLOTEESTQ, C_ATUAINVENTOK.NRSUBLOTE,
              V_TIPOMOV, V_CUSTOPROD, V_CUSTOPROD, C_ATUAINVENTOK.DTINVELOTE, (V_CUSTOPROD * V_VRFATOCONV), (V_CUSTOPROD * C_ATUAINVENTOK.QTINVELOTE), V_IDORDEMCLC);

           /* ATUALIZA O INVENTARIO DO PRODUTO */
          UPDATE INVEROTALOTE
             SET IDINVLOTEOK = 'S'
           WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
             AND DTINVELOTE = C_ATUAINVENTOK.DTINVELOTE
             AND CDALMOXARIFE = C_ATUAINVENTOK.CDALMOXARIFE
             AND CDLOCALESTOQ = C_ATUAINVENTOK.CDLOCALESTOQ
             AND CDPRODUTO = C_ATUAINVENTOK.CDPRODUTO
             AND NRLOTEESTQ = C_ATUAINVENTOK.NRLOTEESTQ
             AND NRSUBLOTE = C_ATUAINVENTOK.NRSUBLOTE;
        END IF;

        IF (V_IDCTRLESTQ <> 'N') THEN
        /* ATUALIZA REGISTRO DE PRODUTOS POR LOCAL DE ESTOQUE, SE A FILIAL CONTROLA ESTOQUE */
        INSERT INTO PRODLCESTOQ
         (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
        (SELECT C_ATUAINVENTOK.CDFILIAL, C_ATUAINVENTOK.CDALMOXARIFE, C_ATUAINVENTOK.CDLOCALESTOQ, V_CDPRODESTO
          FROM PRODFILI
           WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
             AND CDPRODUTO = V_CDPRODESTO
             AND NVL(IDCNTRESTOQ, 'S') <> 'N'
           MINUS
          SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
            FROM PRODLCESTOQ
           WHERE CDFILIAL = C_ATUAINVENTOK.CDFILIAL
             AND CDALMOXARIFE = C_ATUAINVENTOK.CDALMOXARIFE
             AND CDLOCALESTOQ = C_ATUAINVENTOK.CDLOCALESTOQ
             AND CDPRODUTO = V_CDPRODESTO);
        END IF;
      END LOOP;

      IF (V_NRAJUSTE IS NOT NULL) THEN
         IF (P_INOPCAO = 3 ) THEN
            /* SE A OPCAO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
            E QUE NAO ESTAO CADASTRADOS NO INVENTARIO, SERAO ZERADOS */
            FOR C_ZERAEST IN (SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
                                FROM POSESTDIA A,
                                    (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                                       FROM POSESTDIA
                                      WHERE CDFILIAL = P_CDFILIAL
                                        AND CDALMOXARIFE = V_ALMOXARIF
                                        AND CDLOCALESTOQ = V_LOCALEST
                                        AND DTPOSIESTQ < V_DTMOVI
                                      GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
                                WHERE A.CDFILIAL = P_CDFILIAL
                                  AND A.CDALMOXARIFE = V_ALMOXARIF
                                  AND A.CDLOCALESTOQ = V_LOCALEST
                                  AND A.CDFILIAL = X.CDFILIAL
                                  AND A.CDPRODUTO = X.CDPRODUTO
                                  AND A.CDALMOXARIFE = X.CDALMOXARIFE
                                  AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                                  AND A.NRLOTEESTQ = X.NRLOTEESTQ
                                  AND A.NRSUBLOTE = X.NRSUBLOTE
                                  AND A.DTPOSIESTQ = X.DTPOSIESTQ
                                  AND A.QTESTOQDIA <> 0
                                  AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE
                                                      FROM INVEROTALOTE I,
                                                           (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                                                              FROM INVEROTALOTE
                                                             WHERE CDFILIAL = P_CDFILIAL
                                                               AND CDALMOXARIFE = V_ALMOXARIF
                                                               AND CDLOCALESTOQ = V_LOCALEST
                                                               AND DTINVELOTE < V_DTMOVI
                                                             GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) B
                                                     WHERE I.CDFILIAL = P_CDFILIAL
                                                       AND I.CDALMOXARIFE = V_ALMOXARIF
                                                       AND I.CDLOCALESTOQ = V_LOCALEST
                                                       AND I.CDFILIAL = B.CDFILIAL
                                                       AND I.CDPRODUTO = B.CDPRODUTO
                                                       AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                                       AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                                       AND I.NRLOTEESTQ = B.NRLOTEESTQ
                                                       AND I.NRSUBLOTE = B.NRSUBLOTE
                                                       AND I.DTINVELOTE = B.DTINVELOTE
                                                       AND A.CDFILIAL = I.CDFILIAL
                                                       AND A.CDPRODUTO = I.CDPRODUTO
                                                       AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                                       AND A.CDLOCALESTOQ = I.CDLOCALESTOQ
                                                       AND A.NRLOTEESTQ = I.NRLOTEESTQ
                                                       AND A.NRSUBLOTE = I.NRSUBLOTE)) LOOP

                  IF (V_NRSEQAJU = 9999) THEN
                     IF (P_EVOLEST = 'S') THEN
                        FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                             FROM MOVILOTE
                                            WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                           UPDATE ITLANCTOEST
                              SET IDEVOLESTOQ = 'S'
                            WHERE CDFILIAL = P_CDFILIAL
                              AND NRLANCESTQ = V_NRAJUSTE
                              AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                              AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                              AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                              AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                              AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                        END LOOP;
                        ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);
                     ELSE
                        UPDATE ITLANCTOEST
                           SET IDEVOLESTOQ = 'N'
                         WHERE CDFILIAL = P_CDFILIAL
                           AND NRLANCESTQ = V_NRAJUSTE;
                     END IF;

                     NOVO_CODIGO('LANCTOEST'||P_CDFILIAL, V_NRAJUSTE);
                     V_NRAJUSTE := SUBSTR(V_NRAJUSTE, 11, 20);

                     INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                     VALUES (P_CDFILIAL, V_NRAJUSTE, V_TIPOMOV, V_DTMOVI, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);

                     V_NRSEQAJU := 0;
                  END IF;

                  V_NRSEQAJU := V_NRSEQAJU + 1;

                  INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE,
                  CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                  VALUES
                  (P_CDFILIAL, V_NRAJUSTE, LPAD(TO_CHAR(V_NRSEQAJU),4,'0'), C_ZERAEST.CDPRODUTO, 0, 0, C_ZERAEST.CDPRODUTO, 'N', P_CDFILIMOVI, C_ZERAEST.CDALMOXARIFE,
                  C_ZERAEST.CDLOCALESTOQ, C_ZERAEST.NRLOTEESTQ, C_ZERAEST.NRSUBLOTE, '1', 0, 0, V_DTMOVI, 0, 0, V_IDORDEMCLC);
                                 
                  UPDATE (SELECT E.*
                            FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                          AND E.NRLANCTONF  = I.NRLANCTONF
                                                                          AND E.NRSEQITPROD = I.NRSEQITPROD
                           WHERE I.CDFILIMOVI   = P_CDFILIMOVI
                             AND I.CDPRODUTO    = C_ZERAEST.CDPRODUTO
                             AND I.CDALMOXARIFE = C_ZERAEST.CDALMOXARIFE
                             AND I.NRLOTEESTQ   = C_ZERAEST.NRLOTEESTQ
                             AND I.CDLOCALESTOQ = C_ZERAEST.CDLOCALESTOQ
                             AND I.NRSUBLOTE    = C_ZERAEST.NRSUBLOTE
                             AND E.IDSTATUSETIQ <> 'I')
                     SET IDSTATUSETIQ = 'I',
                         DSNOTAFISORIGET = 'INV '||TO_CHAR(SYSDATE, 'DD/MM/YYYY');
               END LOOP;
            END IF;

            IF (P_EVOLEST = 'S') THEN
               /* ATUALIZA A ULTIMA MOVIMENTACAO DE AJUSTE E MOVIMENTACAO DE RETIRADA NO ESTOQUE */
               FOR C_MOVIAJU IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                   FROM MOVILOTE
                                  WHERE NRMOVILOTE = P_CDFILIAL || V_NRAJUSTE) LOOP
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ = 'S'
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NRLANCESTQ = V_NRAJUSTE
                     AND CDPRODUTO = C_MOVIAJU.CDPRODUTO
                     AND CDALMOXARIFE = C_MOVIAJU.CDALMOXARIFE
                     AND CDLOCALESTOQ = C_MOVIAJU.CDLOCALESTOQ
                     AND NRLOTEESTQ  = C_MOVIAJU.NRLOTEESTQ
                     AND NRSUBLOTE = C_MOVIAJU.NRSUBLOTE;
               END LOOP;
               ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRAJUSTE);

               IF (V_IDGERARETAJU = 'S') THEN
                  FOR C_MOVIRET IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                      FROM MOVILOTE
                                     WHERE NRMOVILOTE = P_CDFILIAL || V_NRLANCESTRET) LOOP
                     UPDATE ITLANCTOEST
                        SET IDEVOLESTOQ = 'S'
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NRLANCESTQ = V_NRLANCESTRET
                        AND CDPRODUTO = C_MOVIRET.CDPRODUTO
                        AND CDALMOXARIFE = C_MOVIRET.CDALMOXARIFE
                        AND CDLOCALESTOQ = C_MOVIRET.CDLOCALESTOQ
                        AND NRLOTEESTQ  = C_MOVIRET.NRLOTEESTQ
                        AND NRSUBLOTE = C_MOVIRET.NRSUBLOTE;
                  END LOOP;
                  ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRLANCESTRET);
               END IF;
            ELSE
               UPDATE ITLANCTOEST
                  SET IDEVOLESTOQ = 'N'
                WHERE CDFILIAL = P_CDFILIAL
                  AND NRLANCESTQ = V_NRAJUSTE;
               IF (V_IDGERARETAJU = 'S') THEN
                  UPDATE ITLANCTOEST
                     SET IDEVOLESTOQ = 'N'
                   WHERE CDFILIAL = P_CDFILIAL
                     AND NRLANCESTQ = V_NRLANCESTRET;
               END IF;
            END IF;
         END IF;
         /*    INCLUSAO DE IMPLANTACAO DE ESTOQUE     */
         V_ALMOXARIF := 'NOVO';
         V_LOCALEST  := 'NOVO';
         FOR C_ATUAIMP IN C_INVLOTEOK LOOP
            SELECT CDPRODESTO, VRFATOCONV
              INTO V_CDPRODESTO, V_VRFATOCONV
              FROM PRODUTO
             WHERE CDPRODUTO = C_ATUAIMP.CDPRODUTO;

            V_CUSTOPROD := CUSTO_PRODUTO_LCEST(C_ATUAIMP.CDFILIAL, V_CDPRODESTO, 3, C_ATUAIMP.DTINVELOTE, SYSDATE, C_ATUAIMP.CDALMOXARIFE,
                                               C_ATUAIMP.CDLOCALESTOQ, C_ATUAIMP.NRLOTEESTQ, C_ATUAIMP.NRSUBLOTE);

            IF (V_CUSTOPROD IS NULL) THEN
               V_CUSTOPROD := 0;
            ELSE
               V_CUSTOPROD := V_CUSTOPROD * V_VRFATOCONV;
            END IF;

            IF (C_ATUAIMP.QTESTOLOTE = 0) THEN
               V_QTESTOQDIA := C_ATUAIMP.QTESTOLOTE;
            ELSE
               V_QTESTOQDIA := C_ATUAIMP.QTESTOLOTE / V_VRFATOCONV;
            END IF;

            IF (V_VRFATOCONV = 1) THEN
               V_QTINVROTA := C_ATUAIMP.QTINVELOTE;
            ELSE
               V_QTINVROTA := C_ATUAIMP.QTINVELOTE * V_VRFATOCONV;
            END IF;

            IF (V_IDORDAJUINVE = 'U') THEN
               V_DTPOSESTDIA := C_ATUAIMP.DTINVELOTE ;
            ELSE
               V_DTPOSESTDIA := C_ATUAIMP.DTINVELOTE - 1;
            END IF;

            V_TIPOMOV := '0';

            IF ((V_ALMOXARIF <> C_ATUAIMP.CDALMOXARIFE) OR (V_LOCALEST <> C_ATUAIMP.CDLOCALESTOQ) OR (V_NRSEQIMP = 9999)) THEN
               V_ALMOXARIF := C_ATUAIMP.CDALMOXARIFE;
               V_LOCALEST := C_ATUAIMP.CDLOCALESTOQ;

               IF (V_NRIMPLANTA IS NOT NULL) THEN
                  IF (P_EVOLEST = 'S') THEN
                     FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                          FROM MOVILOTE
                                         WHERE NRMOVILOTE = P_CDFILIAL || V_NRIMPLANTA) LOOP
                        UPDATE ITLANCTOEST
                           SET IDEVOLESTOQ = 'S'
                         WHERE CDFILIAL = P_CDFILIAL
                           AND NRLANCESTQ = V_NRIMPLANTA
                           AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                           AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                           AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                           AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                           AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
                     END LOOP;
                     ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRIMPLANTA);
                  ELSE
                     UPDATE ITLANCTOEST
                        SET IDEVOLESTOQ = 'N'
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NRLANCESTQ = V_NRIMPLANTA;
                  END IF;
               END IF;

               NOVO_CODIGO('LANCTOEST'||C_ATUAIMP.CDFILIAL, V_NRIMPLANTA);
               V_NRIMPLANTA := SUBSTR(V_NRIMPLANTA, 11, 20);

               V_DESCALMOX := 'Implantacao para Inventario Rotativo';
               IF (V_IDUTILALMOX = 'S') THEN
                  V_DESCALMOX := V_DESCALMOX||' - Almox. '||C_ATUAIMP.CDALMOXARIFE;
                  IF (V_IDUTILLCESTQ = 'S') THEN
                     V_DESCALMOX := V_DESCALMOX||' Local. '||C_ATUAIMP.CDLOCALESTOQ;
                  END IF;
               END IF;

               /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - IMPLANTACAO */
               INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
               VALUES (C_ATUAIMP.CDFILIAL, V_NRIMPLANTA, V_TIPOMOV, C_ATUAIMP.DTINVELOTE, P_CDFILIMOVI, P_CDOPERADOR, V_DESCALMOX);

               V_NRSEQIMP := 0;
            END IF;

            V_NRSEQIMP := V_NRSEQIMP + 1;

            /* INSERE O ITEM DO LANCAMENTO DE MOVIMENTACAO DE ESTOQUE - IMPLANTACAO */
            INSERT INTO ITLANCTOEST
            (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
            CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
            NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
            VRTOTLANCTO, IDORDEMCLC)
            VALUES
            (C_ATUAIMP.CDFILIAL, V_NRIMPLANTA, LPAD(TO_CHAR(V_NRSEQIMP),4,'0'), C_ATUAIMP.CDPRODUTO, V_QTINVROTA, C_ATUAIMP.QTINVELOTE, V_CDPRODESTO,
            'N', P_CDFILIMOVI, C_ATUAIMP.CDALMOXARIFE, C_ATUAIMP.CDLOCALESTOQ, C_ATUAIMP.NRLOTEESTQ, C_ATUAIMP.NRSUBLOTE, V_TIPOMOV, V_CUSTOPROD,
            V_CUSTOPROD, C_ATUAIMP.DTINVELOTE, (V_CUSTOPROD * V_VRFATOCONV), (V_CUSTOPROD * C_ATUAIMP.QTINVELOTE), V_IDORDEMCLC);

            /* ATUALIZA O INVENTARIO DO PRODUTO */
            UPDATE INVEROTALOTE
               SET IDINVLOTEOK = 'S'
             WHERE CDFILIAL = C_ATUAIMP.CDFILIAL
               AND DTINVELOTE = C_ATUAIMP.DTINVELOTE
               AND CDALMOXARIFE = C_ATUAIMP.CDALMOXARIFE
               AND CDLOCALESTOQ = C_ATUAIMP.CDLOCALESTOQ
               AND CDPRODUTO = C_ATUAIMP.CDPRODUTO
               AND NRLOTEESTQ = C_ATUAIMP.NRLOTEESTQ
               AND NRSUBLOTE = C_ATUAIMP.NRSUBLOTE;
         END LOOP;


        IF (V_NRIMPLANTA IS NOT NULL) THEN
           IF (P_EVOLEST = 'S') THEN
              FOR C_MOVILOTE IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                   FROM MOVILOTE
                                  WHERE NRMOVILOTE = P_CDFILIAL || V_NRIMPLANTA) LOOP
                 UPDATE ITLANCTOEST
                    SET IDEVOLESTOQ = 'S'
                  WHERE CDFILIAL = P_CDFILIAL
                    AND NRLANCESTQ = V_NRIMPLANTA
                    AND CDPRODUTO = C_MOVILOTE.CDPRODUTO
                    AND CDALMOXARIFE = C_MOVILOTE.CDALMOXARIFE
                    AND CDLOCALESTOQ = C_MOVILOTE.CDLOCALESTOQ
                    AND NRLOTEESTQ  = C_MOVILOTE.NRLOTEESTQ
                    AND NRSUBLOTE = C_MOVILOTE.NRSUBLOTE;
              END LOOP;
              ATUALIZA_ESTOQUE(P_CDFILIMOVI, V_DTPOSESTDIA, P_DATAPROC, P_CDFILIAL, V_NRIMPLANTA);
           ELSE
              UPDATE ITLANCTOEST
                 SET IDEVOLESTOQ = 'N'
               WHERE CDFILIAL = P_CDFILIAL
                 AND NRLANCESTQ = V_NRIMPLANTA;
           END IF;
        END IF;
     END IF;
     COMMIT;
   END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_INVENTARIO_ESTOQUE','6.05.XXX'); END;
/
