/* Sistemas Integrados TECNISA

Nome: 8987_SUPTRGO_LOG_SUP_PEDIDOEXOL.SQL

Descrio:
   Trigger para gravar o registro de alteraes na tabela PEDIDOEXOL.

Criao:
   13/08/2008 - Davidson Henrique Gontijo
*/
/* Tabela PEDIDOEXOL: Lanamento de Pedidos do OL */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PEDIDOEXOL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Lanamento de Pedidos do OL,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_SUP_PEDIDOEXOL
AFTER DELETE OR INSERT OR UPDATE
ON PEDIDOEXOL FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
      IF (NVL(:OLD.DTPEDEXOL, TO_DATE('01/01/1900', 'DD/MM/YYYY')) <> NVL(:NEW.DTPEDEXOL, TO_DATE('01/01/1900', 'DD/MM/YYYY'))) THEN
         V_DESC := 'DT Oper.' ||''|| NVL(:NEW.DTPEDEXOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDBAIXEXOL, 'X') <> NVL(:NEW.IDBAIXEXOL, 'X')) THEN
         V_DESC := 'ID Baixa'||''|| NVL(:NEW.IDBAIXEXOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDBAIXEXSAI, 'X') <> NVL(:NEW.IDBAIXEXSAI, 'X')) THEN
         V_DESC := 'ID Sada'  ||''|| NVL(:NEW.IDBAIXEXSAI,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDEMITEXOL, 'X') <> NVL(:NEW.IDEMITEXOL, 'X')) THEN
         V_DESC := 'ID Emitente(NF Dest.)' ||''|| NVL(:NEW.IDEMITEXOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDTPFRETEXOL, 'X') <> NVL(:NEW.IDTPFRETEXOL, 'X')) THEN
         V_DESC := 'ID Frete'  ||''|| NVL(:NEW.IDTPFRETEXOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDTPJTREXOL, 'X') <> NVL(:NEW.IDTPJTREXOL, 'X')) THEN
         V_DESC := 'ID Insc. Jur. Trans.'  ||''|| NVL(:NEW.IDTPJTREXOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.NRINSJTREXOL, 'X') <> NVL(:NEW.NRINSJTREXOL, 'X')) THEN
         V_DESC := 'Insc. Jur. Trans.' ||''|| NVL(:NEW.NRINSJTREXOL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDEMPRESA, 'X') <> NVL(:NEW.CDEMPRESA, 'X')) THEN
         V_DESC := 'Empresa'  ||''|| NVL(:NEW.CDEMPRESA,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDTIPCOB, 'X') <> NVL(:NEW.CDTIPCOB, 'X')) THEN
         V_DESC := 'Tipo Cobr.' ||''|| NVL(:NEW.CDTIPCOB,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDTPCTPAGAR, 'X') <> NVL(:NEW.CDTPCTPAGAR, 'X')) THEN
         V_DESC := 'Conta a PG.' ||''|| NVL(:NEW.CDTPCTPAGAR,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDFILIOPELOG, 'X') <> NVL(:NEW.CDFILIOPELOG, 'X')) THEN
         V_DESC := 'Filial de Oper.' ||''|| NVL(:NEW.CDFILIOPELOG,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDTIPOEXOL, 'X') <> NVL(:NEW.IDTIPOEXOL, 'X')) THEN
         V_DESC := 'ID Pedido' ||''|| NVL(:NEW.IDTIPOEXOL,'') ||'   ';
      END IF;
      V_ITPESQ       := :NEW.CDFILDEST|| :NEW.CDFILLANC|| :NEW.NRPEDEXOL;
      V_CDFILLOGOPER := :NEW.CDFILLANC;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   := 'Filial Dest.'            || '' || NVL(:NEW.CDFILDEST, '')       || '  ' ||
                     'Filial Lan.'            || '' || NVL(:NEW.CDFILLANC, '')       || '  ' ||
                     'Pedido'                  || '' || NVL(:NEW.NRPEDEXOL, '')       || '  ' ||
                     'DT Oper.'                || '' || NVL(:NEW.DTPEDEXOL, '')       || '  ' ||
                     'ID Baixa'                || '' || NVL(:NEW.IDBAIXEXOL, '')      || '  ' ||
                     'ID Sada'                || '' || NVL(:NEW.IDBAIXEXSAI, '')     || '  ' ||
                     'ID Emitente(NF Dest.)'   || '' || NVL(:NEW.IDEMITEXOL, '')      || '  ' ||
                     'ID Frete'                || '' || NVL(:NEW.IDTPFRETEXOL, '')    || '  ' ||
                     'ID Insc. Jur. Trans.'    || '' || NVL(:NEW.IDTPJTREXOL, '')     || '  ' ||
                     'Insc. Jur. Trans.'       || '' || NVL(:NEW.NRINSJTREXOL, '')    || '  ' ||
                     'Empresa'                 || '' || NVL(:NEW.CDEMPRESA, '')       || '  ' ||
                     'Tipo Cobr.'              || '' || NVL(:NEW.CDTIPCOB, '')        || '  ' ||
                     'Conta a PG.'             || '' || NVL(:NEW.CDTPCTPAGAR, '')     || '  ' ||
                     'Filial de Oper.'         || '' || NVL(:NEW.CDFILIOPELOG, '')    || '  ' ||
                     'ID Pedido'               || '' || NVL(:NEW.IDTIPOEXOL, '');
         V_ITPESQ       := :NEW.CDFILDEST || :NEW.CDFILLANC|| :NEW.NRPEDEXOL;
         V_CDFILLOGOPER := :NEW.CDFILLANC;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   :=    'Filial Dest.'            || '' || NVL(:OLD.CDFILDEST, '')       || '  ' ||
                           'Filial Lan.'            || '' || NVL(:OLD.CDFILLANC, '')       || '  ' ||
                           'Pedido'                  || '' || NVL(:OLD.NRPEDEXOL, '')       || '  ' ||
                           'DT Oper.'                || '' || NVL(:OLD.DTPEDEXOL, '')       || '  ' ||
                           'ID Baixa'                || '' || NVL(:OLD.IDBAIXEXOL, '')      || '  ' ||
                           'ID Sada'                || '' || NVL(:OLD.IDBAIXEXSAI, '')     || '  ' ||
                           'ID Emitente(NF Dest.)'   || '' || NVL(:OLD.IDEMITEXOL, '')      || '  ' ||
                           'ID Frete'                || '' || NVL(:OLD.IDTPFRETEXOL, '')    || '  ' ||
                           'ID Insc. Jur. Trans.'    || '' || NVL(:OLD.IDTPJTREXOL, '')     || '  ' ||
                           'Insc. Jur. Trans.'       || '' || NVL(:OLD.NRINSJTREXOL, '')    || '  ' ||
                           'Empresa'                 || '' || NVL(:OLD.CDEMPRESA, '')       || '  ' ||
                           'Tipo Cobr.'              || '' || NVL(:OLD.CDTIPCOB, '')        || '  ' ||
                           'Conta a PG.'             || '' || NVL(:OLD.CDTPCTPAGAR, '')     || '  ' ||
                           'Filial de Oper.'         || '' || NVL(:OLD.CDFILIOPELOG, '')    || '  ' ||
                           'ID Pedido'               || '' || NVL(:OLD.IDTIPOEXOL, '');
            V_ITPESQ       := :OLD.CDFILDEST|| :OLD.CDFILLANC|| :OLD.NRPEDEXOL;
            V_CDFILLOGOPER := :OLD.CDFILLANC;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   IF (V_DESC IS NOT NULL) THEN
      V_DESC := SUBSTR(V_DESC, 1, 300);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER,
          CDFILLOGOPER)
      VALUES
         ('PEDIDOEXOL',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER,
          V_CDFILLOGOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_PEDIDOEXOL','5.05.002'); END;
/


